Package org.gradle.api

## Interface DomainObjectSet<T>

- Type Parameters:
    `T` - The type of objects in this set.
  All Superinterfaces:
    `java.util.Collection<T>`, `DomainObjectCollection<T>`, `java.lang.Iterable<T>`, `java.util.Set<T>`
  All Known Subinterfaces:
    `ArtifactTypeContainer`, `AuthenticationContainer`, `BinaryTasksCollection`, `BuildDashboardReports`, `BuildTypeContainer`, `CheckstyleReports`, `CodeNarcReports`, `ConfigurationContainer`, `ConfigurationReports`, `DependencyConstraintSet`, `DependencyReportContainer`, `DependencySet`, `DistributionContainer`, `ExtensiblePolymorphicDomainObjectContainer<T>`, `FlavorContainer`, `IvyArtifactSet`, `IvyConfigurationContainer`, `JacocoReportsContainer`, `MavenArtifactSet`, `MutableVersionCatalogContainer`, `NamedDomainObjectContainer<T>`, `NamedDomainObjectSet<T>`, `NativeExecutableBinarySpec.TasksCollection`, `NativeTestSuiteBinarySpec.TasksCollection`, `NativeToolChainRegistry`, `PlatformContainer`, `PluginCollection<T>`, `PluginContainer`, `PmdReports`, `PolymorphicDomainObjectContainer<T>`, `PrebuiltLibraries`, `ProjectSourceSet`, `PublicationContainer`, `PublishArtifactSet`, `ReportContainer<T>`, `Repositories`, `SharedLibraryBinarySpec.TasksCollection`, `SoftwareComponentContainer`, `SourceSetContainer`, `StaticLibraryBinarySpec.TasksCollection`, `TaskCollection<T>`, `TaskContainer`, `TestSuiteTaskCollection`, `TestTaskReports`

      public interface DomainObjectSet<T>
      extends DomainObjectCollection<T>, java.util.Set<T>

  A `DomainObjectSet` is a specialization of `DomainObjectCollection` that guarantees `Set` semantics.

  You can create an instance of this type using the factory method `ObjectFactory.domainObjectSet(Class)`.

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `java.util.Set<T>` | `findAll​(Closure spec)` | Returns a collection which contains the objects in this collection which meet the given closure specification.
    `DomainObjectSet<T>` | `matching​(Closure spec)` | Returns a collection which contains the objects in this collection which meet the given closure specification.
    `DomainObjectSet<T>` | `matching​(Spec<? super T> spec)` | Returns a collection which contains the objects in this collection which meet the given specification.
    `<S extends T> DomainObjectSet<S>` | `withType​(java.lang.Class<S> type)` | Returns a collection containing the objects in this collection of the given type.

    - ### Methods inherited from interface java.util.Collection

      `parallelStream, removeIf, stream, toArray`

    - ### Methods inherited from interface org.gradle.api.DomainObjectCollection

      `addAllLater, addLater, all, all, configureEach, whenObjectAdded, whenObjectAdded, whenObjectRemoved, whenObjectRemoved, withType, withType`

    - ### Methods inherited from interface java.lang.Iterable

      `forEach`

    - ### Methods inherited from interface java.util.Set

      `add, addAll, clear, contains, containsAll, equals, hashCode, isEmpty, iterator, remove, removeAll, retainAll, size, spliterator, toArray, toArray`

- - ### Method Detail

    - #### withType

          <S extends T> DomainObjectSet<S> withType​(java.lang.Class<S> type)

      Returns a collection containing the objects in this collection of the given type. The returned collection is live, so that when matching objects are later added to this collection, they are also visible in the filtered collection.
      Specified by:
        `withType` in interface `DomainObjectCollection<T>`
      Parameters:
        `type` - The type of objects to find.
      Returns:
        The matching objects. Returns an empty collection if there are no such objects in this collection.

    - #### matching

          DomainObjectSet<T> matching​(Spec<? super T> spec)

      Returns a collection which contains the objects in this collection which meet the given specification. The returned collection is live, so that when matching objects are added to this collection, they are also visible in the filtered collection.
      Specified by:
        `matching` in interface `DomainObjectCollection<T>`
      Parameters:
        `spec` - The specification to use.
      Returns:
        The collection of matching objects. Returns an empty collection if there are no such objects in this collection.

    - #### matching

          DomainObjectSet<T> matching​(Closure spec)

      Returns a collection which contains the objects in this collection which meet the given closure specification. The returned collection is live, so that when matching objects are added to this collection, they are also visible in the filtered collection.
      Specified by:
        `matching` in interface `DomainObjectCollection<T>`
      Parameters:
        `spec` - The specification to use. The closure gets a collection element as an argument.
      Returns:
        The collection of matching objects. Returns an empty collection if there are no such objects in this collection.

    - #### findAll

          java.util.Set<T> findAll​(Closure spec)

      Returns a collection which contains the objects in this collection which meet the given closure specification.
      Specified by:
        `findAll` in interface `DomainObjectCollection<T>`
      Parameters:
        `spec` - The specification to use. The closure gets a collection element as an argument.
      Returns:
        The collection of matching objects. Returns an empty collection if there are no such objects in this collection.